function OnInit()
	
	this:SetVisualProfile("~/spark.xml", "spell");
	this:LoadCollisionInfo("~/spark.col");
	this:SetPersistent(false); --//don't bother saving this
	m_parent = nil;
	m_canHit = false;
	this:SetDensity(1);
	this:SetBlendMode(C_BLEND_MODE_ADDITIVE);
	--this:SetBaseColor(Color(255,255,255,150));
	this:SetCollisionCategories(C_CATEGORIES_NONE);
	this:SetDesiredSpeed(10);
	m_baseSpeed = 10;
	this:SetAcceleration(10);
	this:SetTurnSpeed(1.0);
	this:SetDampening(0.1);
	
end

function OnPostInit()

	--//tell us to die soon
	Schedule(1200, this:GetID(), "this:SetDeleteFlag(true);");
	SetupParticleSystem();
	if (GetPlayer != nil) then
		this:SetLayerID(GetPlayer:GetLayerID()+1);
	end

end

function OnKill()


end

function SetParent(parent)
	m_parent = parent;
	
	local facing, vDir, speedMod = ConvertFacingToIso(m_parent:GetFacing());
	
	this:SetDesiredSpeed(m_baseSpeed*speedMod); --//if we wanted custom control of speed per dir
	
	this:SetVectorFacingTarget(vDir); --//turn the way we want
	
	--//GetSoundManager:Play("audio/effects/coin.ogg");
	this:GetBrainManager():Add("StandardBase", "");
	this:GetBrainManager():SetStateByName("Walk");
	this:SetCollisionListenCategory(C_CATEGORY_ENTITY, true);
	this:SetCollisionListenCategory(C_CATEGORY_ENEMY, true);
	this:SetCollisionListenCategory(C_CATEGORY_CHARACTER, true);
	Schedule(1, this:GetID(), "m_canHit = true;");
end


function ConvertFacingToIso(parentfacing)

	local speedMod = 1; --//normal
	
	local facing;
			
		facing = parentfacing;

	local v = FacingToVector(facing); --//convert to a vector
	

	if (facing == C_FACING_UP_RIGHT or facing == C_FACING_DOWN_LEFT) then
		--//fix it so the character walks exactly on the line we want, not sure why we need to do this
	
		local angle = math.atan2(v.x,v.y);
		
		--//rotate just a bit clockwise
		angle = angle + -0.32175;
		
		--//convert back to a vector
		v = Vector2(math.sin(angle), math.cos(angle));
	end

	if (facing == C_FACING_DOWN_RIGHT or facing == C_FACING_UP_LEFT) then
		--//fix it so the character walks exactly on the line we want, not sure why we need to do this
	
		local angle = math.atan2(v.x,v.y);
		
		--//rotate just a bit clockwise
		angle = angle + 0.32175;
		
		--//convert back to a vector
		v = Vector2(math.sin(angle), math.cos(angle));

	end


	if (facing == C_FACING_UP or facing == C_FACING_DOWN) then
			speedMod = 0.7; --//can't move as fast this way
	end

	return facing, v, speedMod;
end




function OnAction(enemy)

end


function OnCollision(vPosition, vVelocity, vNormal, depth, materialID, entity, state)

	if (m_canHit == false or entity == nil) then
	  return;
	end
	
	if (entity:GetID() == m_parent:GetID()) then
		
	else
		
  		entity:RunFunctionIfExists("OnDamage", vNormal, depth, m_parent, 5, 0, this);
	end
	
		Schedule(1, this:GetID(), "m_canHit = false;");
		Schedule(100, this:GetID(), "this:SetDeleteFlag(true);");

	return; --//don't allow collision to happen

end

function SetupParticleSystem()

	--//setup a particle system of blue trailing sparkles
	
	local particle = GetEffectManager:GetParticleByName("simple");
	
	if (not particle) then
		--//this means we need to create it, only happens once during the game - if you
		--//change these settings, you will need to restart the engine! Or, make changes
		--//to the existing "simple", it will modify all instances using it on the fly
		particle = GetEffectManager:CreateParticle("simple", "effects/media/small.png", 1000);
		particle:SetColor(Color(50,62,155,255));
		particle:SetColoring1(Color(0,80,100,0), 0.8);
		particle:GetMotionController():Set1DAcceleration(-0.0003);
		particle:GetMotionController():SetMaxSpeed(0.1);
		
	end
	
	m_pEffectExplosion = GetEffectManager:CreateEffectExplosion(16,10,12,0.1);
	m_pEffectExplosion:AddParticle(particle, C_PROBABILITY_DEFAULT);
	m_pEffectExplosion:SetLifeDistortion(700);
	
	this:AddEffect(m_pEffectExplosion);

end


